
c=======================================================================
      FUNCTION BILINEAR_OUTER(x1,x2,y1,y2,x,y,f11,f12,f21,f22)
c=======================================================================
c  bilinear.f
c  Interpolation scheme from:
c  http://supercomputingblog.com/graphics/coding-bilinear-interpolation/
c  There are several equivalent ways to calculate the value of P. 
c  An easy way to calculate the value of P would be to first find 
c  the value of the two blue dots, R2, and R1. R2 is effectively a
c  weighted average of Q12 and Q22, while R1 is a weighted average of 
c  Q11 and Q21.

c  R1 = ((x2 – x)/(x2 – x1))*Q11 + ((x – x1)/(x2 – x1))*Q21
c  R2 = ((x2 – x)/(x2 – x1))*Q12 + ((x – x1)/(x2 – x1))*Q22

c  After the two R values are calculated, the value of P can finally be 
c  calculated by a weighted average of R1 and R2.

c  P = ((y2 – y)/(y2 – y1))*R1 + ((y – y1)/(y2 – y1))*R2

      IMPLICIT NONE

cm    REAL VARIABLE DECLARATIONS
      REAL(KIND=8) BILINEAR_OUTER
      REAL(KIND=8) x1,x2, y1, y2, x, y, f11, f12, f21, f22, R1, R2
      IF (x2.NE.x1) THEN
        R1=((x2-x)/(x2-x1))*f11 + ((x-x1)/(x2-x1))*f21
        R2=((x2-x)/(x2-x1))*f12 + ((x-x1)/(x2-x1))*f22
        BILINEAR_OUTER=((y2-y)/(y2-y1))*R1 + ((y-y1)/(y2-y1))*R2
      ELSE
        BILINEAR_OUTER=((y2-y)/(y2-y1))*f11 + ((y-y1)/(y2-y1))*f21
      ENDIF

c      PRINT*, x, x1, x2
c      PRINT*, y, y1, y2
c      PRINT*, R1, R2, BILINEAR

      RETURN

      END
c===================END FUNCTION BILINEAR================================
